/*
 * plctimingthread.cpp
 *
 *	08.03.07 - SF: first release  
 *
 *
 */

#include "plctimingthread.h"
#include <math.h> // isfinite()


/* 
 *	plctimingthread::run()
 *	Run  
 */		
//void *plctimingthread::run_undetached(void *)
void plctimingthread::run(void *)  
{
	DEBUG_STREAM << "plctimingthread::"<<__func__<<": entering... twait="<<t_PLCaccess->h_timeout[0]<<endl;
	int pausesec2,pausenano2;
	int twait = t_PLCaccess->h_timeout[0];
	pausesec2 = (int)((twait)/1000);
	pausenano2 = ((twait)%1000)*1000000;
	usleep(pausesec2*1000000+pausenano2/1000);//sleep for heartbeat time, for setup
	
	//for syncronization
	int ch_hour, ch_min;
	ch_hour = TIMEADJUST_DEF_H;
	ch_min = TIMEADJUST_DEF_M;
	char ch_today;
	ch_today = 0;
	
	while (!t_PLCaccess->abortflag) {
		DEBUG_STREAM << "plctimingthread::"<<__func__<<": looping..."<<endl;
		
		int k,l,m;
		k=l=m=0;
	//for syncronization
		time_t tim=time(NULL);
		tm *now=localtime(&tim);
		/*if((now->tm_hour-ch_hour==0)&&(now->tm_min-ch_min==0)&&((now->tm_mday-ch_today)!=0)){//if it's time to sync
			t_PLCaccess->syncronize();
			ch_today = now->tm_mday;//time adjust once a day
		}*/

	//read timestamp
	//TOPUP: topup db80 also changes timestamp51
		local_t.year = t_PLCaccess->tst51.year;
		local_t.month = t_PLCaccess->tst51.month;
		local_t.day = t_PLCaccess->tst51.day;
		local_t.hour = t_PLCaccess->tst51.hour;
		local_t.min = t_PLCaccess->tst51.min;
		local_t.sec = t_PLCaccess->tst51.sec;
		local_t.msec = t_PLCaccess->tst51.msec;

	//wait hbeat ms	
//		usleep(pausesec2*1000000+pausenano2/1000);//sleep for heartbeat time
//		INFO_STREAM << "plctimingthread::run() hbeat ctrl " << t_PLCaccess->hbeat<<" ms"<< endl;

	//wait HALF hbeat ms	
		DEBUG_STREAM << "plctimingthread::"<<__func__<<": waiting for messages..."<<endl;
		usleep(pausesec2*500000+pausenano2/2000);
	//empty deque saving to db
		while(!t_PLCaccess->mesg_list_51.empty()){
			DEBUG_STREAM << "plctimingthread::"<<__func__<<": list 51 not empty"<<endl;
			m_to_log = t_PLCaccess->mesg_list_51.front();
			//log_states(m_to_log);
			log_states_new(m_to_log);
			t_PLCaccess->mesg_list_51.pop_front();
			k++;
		}
		while(!t_PLCaccess->mesg_list_50.empty()){
			DEBUG_STREAM << "plctimingthread::"<<__func__<<": list 50 not empty"<<endl;
			p_to_log = t_PLCaccess->mesg_list_50.front();
			log_people(p_to_log);
			t_PLCaccess->mesg_list_50.pop_front();
			l++;
		}
		while(!t_PLCaccess->mesg_list_80.empty()){
			DEBUG_STREAM << "plctimingthread::"<<__func__<<": list 80 not empty"<<endl;
			t_to_log = t_PLCaccess->mesg_list_80.front();
			log_topup(t_to_log);
			t_PLCaccess->mesg_list_80.pop_front();
			m++;
		}


	//wait for the second HALF hbeat ms	
		usleep(pausesec2*500000+pausenano2/2000);
		INFO_STREAM << "plctimingthread::run() hbeat ctrl " << t_PLCaccess->hbeat<<" ms"<< endl;
		
	//verify timestamp
			
		int equals = 1;
	//if the timestamp is the same
			if((local_t.year != t_PLCaccess->tst51.year)|| (local_t.month != t_PLCaccess->tst51.month)|| (local_t.day != t_PLCaccess->tst51.day)|| (local_t.hour != t_PLCaccess->tst51.hour)|| (local_t.min != t_PLCaccess->tst51.min)|| (local_t.sec != t_PLCaccess->tst51.sec)|| (local_t.msec != t_PLCaccess->tst51.msec))equals = 0;

			
		if(equals == 1){
			t_PLCaccess->set_state(Tango::FAULT);
			t_PLCaccess->set_status(MESG_PLC_TIMEOUT);
			t_PLCaccess->plc_status = false;
			DEBUG_STREAM << "plctimingthread::run() timestamp is not changing" << endl;
		}
		else{
			t_PLCaccess->set_state(Tango::ON);
			t_PLCaccess->set_status("timestamp ok");
			t_PLCaccess->plc_status = true;
			DEBUG_STREAM << "plctimingthread::run() timestamp ok" << endl;
		}

	//empty deque saving to db
		while(!t_PLCaccess->mesg_list_51.empty()){
			m_to_log = t_PLCaccess->mesg_list_51.front();
			//log_states(m_to_log);
			log_states_new(m_to_log);
			t_PLCaccess->mesg_list_51.pop_front();
			k++;
		}
		while(!t_PLCaccess->mesg_list_50.empty()){
			p_to_log = t_PLCaccess->mesg_list_50.front();
			log_people(p_to_log);
			t_PLCaccess->mesg_list_50.pop_front();
			l++;
		}
		while(!t_PLCaccess->mesg_list_80.empty()){
			t_to_log = t_PLCaccess->mesg_list_80.front();
			log_topup(t_to_log);
			t_PLCaccess->mesg_list_80.pop_front();
			m++;
		}
		DEBUG_STREAM << "plctimingthread::popped "<< k <<" packets, " << l <<" msg,  "<< m <<" topup"<< endl;
// temporarily disabled for topup test
		if(!(t_PLCaccess->ctrlnames_ok)){//if ctrlnames are not updated yet
			t_PLCaccess->echo_db122();
		}
		if(!(t_PLCaccess->rondanames_ok)){//if rondanames are not updated yet
			t_PLCaccess->echo_db121();
		}//temporarily disabled for topup test 
	}
}

void plctimingthread::log_states(PLCaccess_ns::db_51 m)
{
	DEBUG_STREAM << "plclgthread::log_states(): entering... !" << endl;
	
	char query[DB_QUERY_LEN];
	memset(query, 0, DB_QUERY_LEN);
	MYSQL_STMT    *stmt;
	MYSQL_BIND    log_bind[2];
	my_ulonglong  affected_rows;
	int           param_count;
	double         double_data;
	unsigned long blob_length;
	my_bool       is_null;
	int y;
	timeval t_now;
	
	uint16_t *sptr = (uint16_t *)&m;
	//swap the remaining bytes because old log expect also these swapped
	for (int i=(4/2);i<(12/2); i++)
		sptr[i] = ntohs(sptr[i]);
	
	memset(query, 0, DB_QUERY_LEN);
	y = snprintf(query, DB_QUERY_LEN-1, "INSERT INTO BoostAccessCtrl.statemsg (timestamp,value) VALUES (?,?)");
	char blob_stat[(sizeof(PLCaccess_ns::db_51))];
	bcopy(&(m), blob_stat, (sizeof(PLCaccess_ns::db_51)));
	gettimeofday(&t_now,NULL);//takes timestamp
	double_data = (double)t_now.tv_sec+(((double)t_now.tv_usec)/1000000);//change
	
	stmt = mysql_stmt_init(&(t_PLCaccess->dbp));
	if (!stmt){
		stringstream tmp;
		tmp << "Error mysql_stmt_init in query='"<<query<<"' err='" <<mysql_error(&(t_PLCaccess->dbp)) <<"'";
		INFO_STREAM << "plctimingthread::"<<__func__ << ": " << tmp.str();
		*t_PLCaccess->attr_DBState_read = false;
		memset(t_PLCaccess->db_error,0,2048);
		strncpy(t_PLCaccess->db_error, tmp.str().c_str(), 2048);
		try
		{
			t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
			t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
		} catch(Tango::DevFailed &e)
		{
			INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
		}
	}
	if (mysql_stmt_prepare(stmt, query, strlen(query))){
		stringstream tmp;
		tmp << "Error mysql_stmt_prepare in query='"<<query<<"' err='" <<mysql_error(&(t_PLCaccess->dbp)) <<"'";
		INFO_STREAM << "plctimingthread::"<<__func__ << ": " << tmp.str();
		*t_PLCaccess->attr_DBState_read = false;
		memset(t_PLCaccess->db_error,0,2048);
		strncpy(t_PLCaccess->db_error, tmp.str().c_str(), 2048);
		try
		{
			t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
			t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
		} catch(Tango::DevFailed &e)
		{
			INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
		}
	}

	param_count= mysql_stmt_param_count(stmt);
	
	if (param_count != 2){
		DEBUG_STREAM << "log: invalid parameter count returned by MySQL" << endl;
	}

	memset(log_bind, 0, sizeof(log_bind));
	log_bind[0].buffer_type= MYSQL_TYPE_DOUBLE;
	log_bind[0].buffer= (char *)&double_data;
	log_bind[0].is_null= 0;
	log_bind[0].length= 0;
	
	log_bind[1].buffer_type= MYSQL_TYPE_BLOB;
	log_bind[1].buffer= (char *)&blob_stat;
	log_bind[1].buffer_length= (sizeof(PLCaccess_ns::db_51));
	log_bind[1].is_null= 0;
	log_bind[1].length= &blob_length;
	
	if (mysql_stmt_bind_param(stmt, log_bind))
	{
		stringstream tmp;
		tmp << "Error mysql_stmt_bind_param in query='"<<query<<"' err='" <<mysql_error(&(t_PLCaccess->dbp)) <<"'";
		INFO_STREAM << "plctimingthread::"<<__func__ << ": " << tmp.str();
		*t_PLCaccess->attr_DBState_read = false;
		memset(t_PLCaccess->db_error,0,2048);
		strncpy(t_PLCaccess->db_error, tmp.str().c_str(), 2048);
		try
		{
			t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
			t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
		} catch(Tango::DevFailed &e)
		{
			INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
		}
	}

	blob_length= (sizeof(PLCaccess_ns::db_51));
	is_null= 0;
		
	if (mysql_stmt_execute(stmt))
	{
		stringstream tmp;
		tmp << "Error mysql_stmt_execute in query='"<<query<<"' err='" <<mysql_error(&(t_PLCaccess->dbp)) <<"'";
		INFO_STREAM << "plctimingthread::"<<__func__ << ": " << tmp.str();
		*t_PLCaccess->attr_DBState_read = false;
		memset(t_PLCaccess->db_error,0,2048);
		strncpy(t_PLCaccess->db_error, tmp.str().c_str(), 2048);
		try
		{
			t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
			t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
		} catch(Tango::DevFailed &e)
		{
			INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
		}
	}
		
	affected_rows= mysql_stmt_affected_rows(stmt);
		
	if (affected_rows != 1)
	{
		DEBUG_STREAM << "log_srvc: invalid affected rows " << endl;
	}
	else
	{
		*t_PLCaccess->attr_DBState_read = true;
		try
		{
			t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
			t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
		} catch(Tango::DevFailed &e)
		{
			INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
		}
	}
	if (mysql_stmt_close(stmt))
		DEBUG_STREAM << "log_srvc: failed while closing the statement" << endl;
	
}

#if 0
void plctimingthread::log_people(PLCaccess_ns::db_50 m)
{
	DEBUG_STREAM << "plclgthread::log_people(): entering... !" << endl;
	char pquery[DB_QUERY_LEN];
	memset(pquery, 0, DB_QUERY_LEN);
	MYSQL_STMT    *pstmt;
	MYSQL_BIND    plog_bind[2];
	my_ulonglong  paffected_rows;
	int           param_count;
	double         double_data;
	unsigned long blob_length;
	my_bool       p_is_null;
	int y;
	timeval t_now;
	
	memset(pquery, 0, DB_QUERY_LEN);
	y = snprintf(pquery, DB_QUERY_LEN-1, "INSERT INTO BoostAccessCtrl.accessmsg (timestamp,value) VALUES (?,?)");
	char blob_stat2[(sizeof(PLCaccess_ns::db_50))];
	bcopy(&(m), blob_stat2, (sizeof(PLCaccess_ns::db_50)));
	gettimeofday(&t_now,NULL);//takes timestamp
	double_data = (double)t_now.tv_sec+(((double)t_now.tv_usec)/1000000);//change
	
	pstmt = mysql_stmt_init(&(t_PLCaccess->dbp));
	if (!pstmt){
		DEBUG_STREAM << "log: mysql_stmt_init(), out of memory" << endl;
	}
	if (mysql_stmt_prepare(pstmt, pquery, strlen(pquery))){
		DEBUG_STREAM << "log: mysql_stmt_prepare(), INSERT failed" << endl;
	}

	param_count= mysql_stmt_param_count(pstmt);
	
	if (param_count != 2){
		DEBUG_STREAM << "log: invalid parameter count returned by MySQL" << endl;
	}

	memset(plog_bind, 0, sizeof(plog_bind));
	plog_bind[0].buffer_type= MYSQL_TYPE_DOUBLE;
	plog_bind[0].buffer= (char *)&double_data;
	plog_bind[0].is_null= 0;
	plog_bind[0].length= 0;
	
	plog_bind[1].buffer_type= MYSQL_TYPE_BLOB;
	plog_bind[1].buffer= (char *)&blob_stat2;
	plog_bind[1].buffer_length= (sizeof(PLCaccess_ns::db_50));
	plog_bind[1].is_null= 0;
	plog_bind[1].length= &blob_length;
	
	if (mysql_stmt_bind_param(pstmt, plog_bind))
		DEBUG_STREAM << "log: mysql_stmt_bind_param() failed" << endl;

	blob_length= (sizeof(PLCaccess_ns::db_50));
	p_is_null= 0;
		
	if (mysql_stmt_execute(pstmt))
		DEBUG_STREAM << "log_srvc: mysql_stmt_execute(), failed" << endl;
		
	paffected_rows= mysql_stmt_affected_rows(pstmt);
		
	if (paffected_rows != 1) 
		DEBUG_STREAM << "log_srvc: invalid affected rows " << endl;
	if (mysql_stmt_close(pstmt))
		DEBUG_STREAM << "log_srvc: failed while closing the statement" << endl;
}
#else

void plctimingthread::log_people(PLCaccess_ns::db_50 m2)
{
	DEBUG_STREAM << "plctimingthread::log_people(): entering... !" << endl;
	PLCaccess_ns::intlck_dbacc m;
	//PLCaccess_ns::intlck_dbacc *mp;
	memcpy(&m,&m2, sizeof(PLCaccess_ns::intlck_dbacc));
	//DEBUG_STREAM << "plctimingthread::log_people(): copyed structure... !" << endl;
	//mp = (PLCaccess_ns::intlck_dbacc *)&m2;

	char query[DB_QUERY_LEN];
	memset(query, 0, DB_QUERY_LEN);
	double		date_double, date_plc;
	my_ulonglong id;
	int y;
	timeval t_now;
	
	time_t rawtime, plc_raw;
	struct tm * ptm, plc_time;

	time ( &rawtime );

	ptm = gmtime ( &rawtime );
	
	
	
	int ret = 0;


	stringstream stat_table_name;
	stat_table_name << "booster_db50_" << (1900+ptm->tm_year);
	

	bool name_found;
	string tmp_name_id;
	my_ulonglong  affected_rows;

	int u=0, v=0, found=0;
	for(int k=0;k<18;k++)
	{
		unsigned int name_id=0;
		bool name_changed=false;
		name_found = false;
		char *name_escaped = NULL;
		char namedb[PLC_NAME_LEN];
		memset(namedb, 0, PLC_NAME_LEN);
		DEBUG_STREAM << "plctimingthread::log_people(): comparing badge["<<k<<"]... -> '" << (char*)&m.badge_l[k][2]<<"'" << endl;
		for(int i=0; i<PLC_NAME_LEN; i++)
		{
			if(m.badge_l[k][i] != t_PLCaccess->blk_db50_buffer[k][i])
			{
				name_changed = true;
				DEBUG_STREAM << "plctimingthread::log_people(): badge["<<k<<"]["<<i<<"] changed ! 0x"<<hex<<(unsigned int)m.badge_l[k][i]<<" != 0x" << (unsigned int)t_PLCaccess->blk_db50_buffer[k][i] <<dec<< endl;
				break;
			}
		}
		if(!name_changed)
			continue;
		try {
			int ind=0;
			char logname[255];
			memset(logname, 0, 255);
			for(int i=0; i<PLC_NAME_LEN; i++)
			{
				if((m.badge_l[k][i]>32)&&(m.badge_l[k][i]<126))
				{
					namedb[ind++] = m.badge_l[k][i];
					sprintf(logname,"%s-0x%x",logname, (unsigned int)m.badge_l[k][i]);
				}
			}
			DEBUG_STREAM << "plctimingthread::log_people(): k="<<k<<" after cleaning name='"<< namedb <<"'|'"<<logname<<"' len="<<ind<< endl;
			if(strlen((const char *)namedb) > 0)
			{
				name_escaped = new char [2 * strlen(namedb) + 1];
				mysql_real_escape_string(&t_PLCaccess->dbp, name_escaped, (const char *)&namedb[0], strlen(namedb));
				
				ostringstream select_str;

				select_str << 
						"SELECT id FROM enabled_user WHERE name='" << name_escaped << "'" <<
						ends;
	
				if(mysql_query(&t_PLCaccess->dbp, select_str.str().c_str()))
				{
					stringstream tmp;
					tmp << "Error in query='"<<select_str.str()<<"' err='" <<mysql_error(&(t_PLCaccess->dbp)) <<"'";
					INFO_STREAM << "plctimingthread::"<<__func__ << ": " << tmp.str();
					*t_PLCaccess->attr_DBState_read = false;
					memset(t_PLCaccess->db_error,0,2048);
					strncpy(t_PLCaccess->db_error, tmp.str().c_str(), 2048);
					try
					{
						t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
						t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
					} catch(Tango::DevFailed &e)
					{
						INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
					}
					return;
				}
				else
				{
					MYSQL_RES *res;
					MYSQL_ROW row;
					res = mysql_use_result(&t_PLCaccess->dbp);
					my_ulonglong num_found = mysql_num_rows(res);
					DEBUG_STREAM << " num_found="<<num_found<<" after query="<<select_str.str();
					//row = mysql_fetch_row(res);
					//if(num_found > 0 /*&& (row = mysql_fetch_row(res))*/)
					if((row = mysql_fetch_row(res)))
					{
						name_found = true;
						tmp_name_id = row[0];
						name_id = atoi(tmp_name_id.c_str());
						DEBUG_STREAM << "plctimingthread::log_people(): found "<<name_escaped<<" id="<< name_id << endl;
						mysql_free_result(res);
					}
					else
					{
						mysql_free_result(res);
						ostringstream insert_str;
						insert_str << 
								"INSERT INTO enabled_user (name, insert_date) VALUES ('" << name_escaped << "',NOW())" <<
								ends;
						if(mysql_query(&t_PLCaccess->dbp, insert_str.str().c_str()))
						{
							stringstream tmp;
							tmp << "Error in query='"<<insert_str.str()<<"' err='" <<mysql_error(&(t_PLCaccess->dbp)) <<"'";
							INFO_STREAM << "plctimingthread::"<<__func__ << ": " << tmp.str();
							*t_PLCaccess->attr_DBState_read = false;
							memset(t_PLCaccess->db_error,0,2048);
							strncpy(t_PLCaccess->db_error, tmp.str().c_str(), 2048);
							try
							{
								t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
								t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
							} catch(Tango::DevFailed &e)
							{
								INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
							}
							return;
						}
						else
						{
							affected_rows = mysql_affected_rows(&t_PLCaccess->dbp);
							if((affected_rows > 0))
							{
								//INFO_STREAM << "plctimingthread::log_people(): Affected row=" << affected_rows << " in query=" << insert_str.str() << endl;
								name_id = mysql_insert_id(&(t_PLCaccess->dbp));
								DEBUG_STREAM << "plctimingthread::log_people(): inserted NEW "<<name_escaped<<" id="<< name_id << endl;
		
								*t_PLCaccess->attr_DBState_read = true;
								try
								{
									t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
									t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
								} catch(Tango::DevFailed &e)
								{
									INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
								}
							}
						}
					}
				}

				
				gettimeofday(&t_now,NULL); //takes timestamp
				date_double = ((double) t_now.tv_sec) + ((double) t_now.tv_usec)/1000000;//change
				long int ll, mm;
				ll = t_PLCaccess->calc_timeval(m.year, m.month, m.day, m.hour, m.min, m.sec, m.wday);
				mm = t_PLCaccess->calc_time_ms(m.msec, m.wday);
				plc_raw = mktime(&plc_time);
				date_plc = ((double)ll) + mm/1000.0;
				memset(query, 0, DB_QUERY_LEN);

				y = snprintf(query, DB_QUERY_LEN-1, "INSERT INTO booster_time_%d SET db_time=%13.3f, plc_time=%13.3f, valid='Y'", 1900+ptm->tm_year, date_double, date_plc);
				// cout << query << endl;
				if (mysql_query(&(t_PLCaccess->dbp), query)) {
					stringstream tmp;
					tmp << "Error in query='"<<query<<"' err='" <<mysql_error(&(t_PLCaccess->dbp)) <<"'";
					INFO_STREAM << "plctimingthread::"<<__func__ << ": " << tmp.str();
					*t_PLCaccess->attr_DBState_read = false;
					memset(t_PLCaccess->db_error,0,2048);
					strncpy(t_PLCaccess->db_error, tmp.str().c_str(), 2048);
					try
					{
						t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
						t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
					} catch(Tango::DevFailed &e)
					{
						INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
					}
					return;
				}
				else
				{
					DEBUG_STREAM << "Inserted OK time. Query='"<<query<<"'"<< endl;
					*t_PLCaccess->attr_DBState_read = true;
					try
					{
						t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
						t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
					} catch(Tango::DevFailed &e)
					{
						INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
					}
				}
				id = mysql_insert_id(&(t_PLCaccess->dbp));
				
				y = snprintf(query, DB_QUERY_LEN-1, "INSERT INTO booster_db50_%d SET time_id=%llu, position=%d, enabled_user_id=%d, present='Y'", 1900+ptm->tm_year, id, k, name_id);
				if(mysql_query(&t_PLCaccess->dbp, query))
				{
					stringstream tmp;
					tmp << "Error in query='"<<query<<"' err='" <<mysql_error(&(t_PLCaccess->dbp)) <<"'";
					INFO_STREAM << "plctimingthread::"<<__func__ << ": " << tmp.str();
					*t_PLCaccess->attr_DBState_read = false;
					memset(t_PLCaccess->db_error,0,2048);
					strncpy(t_PLCaccess->db_error, tmp.str().c_str(), 2048);
					try
					{
						t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
						t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
					} catch(Tango::DevFailed &e)
					{
						INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
					}
					return;
				}
				else
				{
					affected_rows = mysql_affected_rows(&t_PLCaccess->dbp);
					DEBUG_STREAM << "Inserted OK db50. affected_rows="<<affected_rows<<" Query='"<<query<<"'"<< endl;
					*t_PLCaccess->attr_DBState_read = true;
					try
					{
						t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
						t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
					} catch(Tango::DevFailed &e)
					{
						INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
					}
				}
			}
			else	//name not more present in table
			{
				int ind=0;
				//copy name from bufferized message
				for(int i=0; i<PLC_NAME_LEN; i++)
				{
					if((t_PLCaccess->blk_db50_buffer[k][i]>32)&&(t_PLCaccess->blk_db50_buffer[k][i]<126))
						namedb[ind++] = t_PLCaccess->blk_db50_buffer[k][i];
				}
				if(strlen((const char *)namedb) > 0)
				{
					name_escaped = new char [2 * strlen(namedb) + 1];
					mysql_real_escape_string(&t_PLCaccess->dbp, name_escaped, (const char *)&namedb[0], strlen(namedb));
				
					ostringstream select_str;

					select_str << 
							"SELECT id FROM enabled_user WHERE name='" << name_escaped << "'" <<
							ends;
	
					if(mysql_query(&t_PLCaccess->dbp, select_str.str().c_str()))
					{
						stringstream tmp;
						tmp << "Error in query='"<<select_str.str()<<"' err='" <<mysql_error(&(t_PLCaccess->dbp)) <<"'";
						INFO_STREAM << "plctimingthread::"<<__func__ << ": " << tmp.str();
						*t_PLCaccess->attr_DBState_read = false;
						memset(t_PLCaccess->db_error,0,2048);
						strncpy(t_PLCaccess->db_error, tmp.str().c_str(), 2048);
						try
						{
							t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
							t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
						} catch(Tango::DevFailed &e)
						{
							INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
						}
						return;
					}
					else
					{
						MYSQL_RES *res;
						MYSQL_ROW row;
						res = mysql_use_result(&t_PLCaccess->dbp);
						my_ulonglong num_found = mysql_num_rows(res);
						DEBUG_STREAM << " num_found="<<num_found<<" after query="<<select_str.str();
						//row = mysql_fetch_row(res);
					//if(num_found > 0 /*&& (row = mysql_fetch_row(res))*/)
						if((row = mysql_fetch_row(res)))
						{
							name_found = true;
							tmp_name_id = row[0];
							name_id = atoi(tmp_name_id.c_str());
							DEBUG_STREAM << "plctimingthread::log_people(): found "<<name_escaped<<" id="<< name_id << endl;
							mysql_free_result(res);
						}
						*t_PLCaccess->attr_DBState_read = true;
						try
						{
							t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
							t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
						} catch(Tango::DevFailed &e)
						{
							INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
						}
					}

					if(name_found)
					{
						gettimeofday(&t_now,NULL); //takes timestamp
						date_double = ((double) t_now.tv_sec) + ((double) t_now.tv_usec)/1000000;//change
						long int ll, mm;
						ll = t_PLCaccess->calc_timeval(m.year, m.month, m.day, m.hour, m.min, m.sec, m.wday);
						mm = t_PLCaccess->calc_time_ms(m.msec, m.wday);
						plc_raw = mktime(&plc_time);
						date_plc = ((double)ll) + mm/1000.0;
						memset(query, 0, DB_QUERY_LEN);
	
						y = snprintf(query, DB_QUERY_LEN-1, "INSERT INTO booster_time_%d SET db_time=%13.3f, plc_time=%13.3f, valid='Y'", 1900+ptm->tm_year, date_double, date_plc);
					// cout << query << endl;
						if (mysql_query(&(t_PLCaccess->dbp), query)) {
							stringstream tmp;
							tmp << "Error in query='"<<query<<"' err='" <<mysql_error(&(t_PLCaccess->dbp)) <<"'";
							INFO_STREAM << "plctimingthread::"<<__func__ << ": " << tmp.str();
							*t_PLCaccess->attr_DBState_read = false;
							memset(t_PLCaccess->db_error,0,2048);
							strncpy(t_PLCaccess->db_error, tmp.str().c_str(), 2048);
							try
							{
								t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
								t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
							} catch(Tango::DevFailed &e)
							{
								INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
							}
							return;
						}
						else
						{
							DEBUG_STREAM << "Inserted OK time. Query='"<<query<<"'"<< endl;
							*t_PLCaccess->attr_DBState_read = true;
							try
							{
								t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
								t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
							} catch(Tango::DevFailed &e)
							{
								INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
							}
						}
						id = mysql_insert_id(&(t_PLCaccess->dbp));
					
						y = snprintf(query, DB_QUERY_LEN-1, "INSERT INTO booster_db50_%d SET time_id=%llu, position=%d, enabled_user_id=%d, present='N'", 1900+ptm->tm_year, id, k, name_id);
						if(mysql_query(&t_PLCaccess->dbp, query))
						{
							stringstream tmp;
							tmp << "Error in query='"<<query<<"' err='" <<mysql_error(&(t_PLCaccess->dbp)) <<"'";
							INFO_STREAM << "plctimingthread::"<<__func__ << ": " << tmp.str();
							*t_PLCaccess->attr_DBState_read = false;
							memset(t_PLCaccess->db_error,0,2048);
							strncpy(t_PLCaccess->db_error, tmp.str().c_str(), 2048);
							try
							{
								t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
								t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
							} catch(Tango::DevFailed &e)
							{
								INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
							}
							return;
						}
						else
						{
							affected_rows = mysql_affected_rows(&t_PLCaccess->dbp);
							*t_PLCaccess->attr_DBState_read = true;
							try
							{
								t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
								t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
							} catch(Tango::DevFailed &e)
							{
								INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
							}
						}
					}
				}
			}
		}
		catch(...)
		{
			INFO_STREAM << "plctimingthread::log_people(): error escaping '" << namedb << "'" << endl;
		}
		memcpy(t_PLCaccess->blk_db50_buffer[k], m.badge_l[k], PLC_NAME_LEN);
		if(name_escaped)
			delete [] name_escaped;
	}
}
#endif

void plctimingthread::log_topup(PLCaccess_ns::topup_dblog m)
{
	DEBUG_STREAM << "plclgthread::log_topup(): entering... !" << endl;
	
	char query[DB_QUERY_LEN];
	memset(query, 0, DB_QUERY_LEN);
	MYSQL_STMT    *stmt;
	MYSQL_BIND    log_bind[2];
	MYSQL_BIND    dat_bind[1];
	my_ulonglong  affected_rows;
	int           param_count;
	double         double_data;
	unsigned int uint_data;
	unsigned long blob_length;
	my_bool       is_null;
	int y;
	timeval t_now;
	
	memset(query, 0, DB_QUERY_LEN);
	y = snprintf(query, DB_QUERY_LEN-1, "INSERT INTO BoostAccessCtrl.topupmsg (timestamp,shotnumber) VALUES (?,?)");
	double_data = (double)m.topup_tst;
	uint_data = (unsigned int)m.nshot;
	
	stmt = mysql_stmt_init(&(t_PLCaccess->dbp));
	if (!stmt){
		stringstream tmp;
		tmp << "Error mysql_stmt_init in query='"<<query<<"' err='" <<mysql_error(&(t_PLCaccess->dbp)) <<"'";
		INFO_STREAM << "plctimingthread::"<<__func__ << ": " << tmp.str();
		*t_PLCaccess->attr_DBState_read = false;
		memset(t_PLCaccess->db_error,0,2048);
		strncpy(t_PLCaccess->db_error, tmp.str().c_str(), 2048);
		try
		{
			t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
			t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
		} catch(Tango::DevFailed &e)
		{
			INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
		}
	}
	if (mysql_stmt_prepare(stmt, query, strlen(query))){
		stringstream tmp;
		tmp << "Error mysql_stmt_prepare in query='"<<query<<"' err='" <<mysql_error(&(t_PLCaccess->dbp)) <<"'";
		INFO_STREAM << "plctimingthread::"<<__func__ << ": " << tmp.str();
		*t_PLCaccess->attr_DBState_read = false;
		memset(t_PLCaccess->db_error,0,2048);
		strncpy(t_PLCaccess->db_error, tmp.str().c_str(), 2048);
		try
		{
			t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
			t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
		} catch(Tango::DevFailed &e)
		{
			INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
		}
	}

	param_count= mysql_stmt_param_count(stmt);
	
	if (param_count != 2){
		DEBUG_STREAM << "log: invalid parameter count returned by MySQL" << endl;
	}

	memset(log_bind, 0, sizeof(log_bind));
	log_bind[0].buffer_type= MYSQL_TYPE_DOUBLE;
	log_bind[0].buffer= (char *)&double_data;
	log_bind[0].is_null= 0;
	log_bind[0].length= 0;
	
	log_bind[1].buffer_type= MYSQL_TYPE_LONG;
	log_bind[1].buffer= (char *)&uint_data;
	log_bind[1].is_null= 0;
	log_bind[1].length= 0;
	
	if (mysql_stmt_bind_param(stmt, log_bind))
	{
		stringstream tmp;
		tmp << "Error mysql_stmt_bind_param in query='"<<query<<"' err='" <<mysql_error(&(t_PLCaccess->dbp)) <<"'";
		INFO_STREAM << "plctimingthread::"<<__func__ << ": " << tmp.str();
		*t_PLCaccess->attr_DBState_read = false;
		memset(t_PLCaccess->db_error,0,2048);
		strncpy(t_PLCaccess->db_error, tmp.str().c_str(), 2048);
		try
		{
			t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
			t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
		} catch(Tango::DevFailed &e)
		{
			INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
		}
	}

	is_null= 0;
		
	if (mysql_stmt_execute(stmt))
	{
		stringstream tmp;
		tmp << "Error mysql_stmt_execute in query='"<<query<<"' err='" <<mysql_error(&(t_PLCaccess->dbp)) <<"'";
		INFO_STREAM << "plctimingthread::"<<__func__ << ": " << tmp.str();
		*t_PLCaccess->attr_DBState_read = false;
		memset(t_PLCaccess->db_error,0,2048);
		strncpy(t_PLCaccess->db_error, tmp.str().c_str(), 2048);
		try
		{
			t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
			t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
		} catch(Tango::DevFailed &e)
		{
			INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
		}
	}
		
	affected_rows= mysql_stmt_affected_rows(stmt);
		
	if (affected_rows != 1) 
	{
		DEBUG_STREAM << "log_srvc: invalid affected rows " << endl;
	}
	else
	{
		*t_PLCaccess->attr_DBState_read = true;
		try
		{
			t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
			t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
		} catch(Tango::DevFailed &e)
		{
			INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
		}
	}
	if (mysql_stmt_close(stmt))
		DEBUG_STREAM << "log_srvc: failed while closing the statement" << endl;
	
	string q;
	const char* tables[] = {"topup_iboo", "topup_isr","topup_ibsr","topup_i0st","topup_iinj","topup_iacc","topup_ilostst","topup_ilostlt","topup_eff"};
	for(int k=0;k<9;k++){
		sprintf(query, "INSERT INTO BoostAccessCtrl.%s (topupmsg_id,value) VALUES (LAST_INSERT_ID(),%f)",tables[k], isfinite(m.c[k])? m.c[k]: 999);
		// cout << query << endl;
		if (mysql_query(&(t_PLCaccess->dbp), query)) {
			stringstream tmp;
			tmp << "Error in query='"<<query<<"' err='" <<mysql_error(&(t_PLCaccess->dbp)) <<"'";
			INFO_STREAM << "plctimingthread::"<<__func__ << ": " << tmp.str();
			*t_PLCaccess->attr_DBState_read = false;
			memset(t_PLCaccess->db_error,0,2048);
			strncpy(t_PLCaccess->db_error, tmp.str().c_str(), 2048);
			try
			{
				t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
				t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
			} catch(Tango::DevFailed &e)
			{
				INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
			}
		}
		else
		{
			*t_PLCaccess->attr_DBState_read = true;
			try
			{
				t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
				t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
			} catch(Tango::DevFailed &e)
			{
				INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
			}
		}
		/*
		stmt = 0;
		memset(query, 0, DB_QUERY_LEN);
		q.clear();
		q+="INSERT INTO BoostAccessCtrl.";
		q+=tables[k];
		q+=" (topupmsg_id,value) VALUES (LAST_INSERT_ID(),?)";
		y = snprintf(query, DB_QUERY_LEN-1, q.c_str());
		double_data = (double)m.c[k];	
		stmt = mysql_stmt_init(&(t_PLCaccess->dbp));
		if (!stmt)DEBUG_STREAM << "log: mysql_stmt_init(), out of memory" << endl;
		if (mysql_stmt_prepare(stmt, query, strlen(query)))DEBUG_STREAM << "log: mysql_stmt_prepare(), INSERT failed" << endl;
		param_count= mysql_stmt_param_count(stmt);	
		if (param_count != 1)DEBUG_STREAM << "log: invalid parameter count returned by MySQL" << endl;
		memset(log_bind, 0, sizeof(log_bind));
		dat_bind[0].buffer_type= MYSQL_TYPE_DOUBLE;
		dat_bind[0].buffer= (char *)&double_data;
		dat_bind[0].is_null= 0;
		dat_bind[0].length= 0;
		if (mysql_stmt_bind_param(stmt, dat_bind))DEBUG_STREAM << "log: mysql_stmt_bind_param() failed" << endl;
		is_null= 0;	
		if (mysql_stmt_execute(stmt))DEBUG_STREAM << "log_srvc: mysql_stmt_execute(), failed" << endl;
		affected_rows= mysql_stmt_affected_rows(stmt);
		if (affected_rows != 1)DEBUG_STREAM << "log_srvc: invalid affected rows " << endl;
		if (mysql_stmt_close(stmt))DEBUG_STREAM << "log_srvc: failed while closing the statement" << endl;
		*/
	}
}

void plctimingthread::log_states_new(PLCaccess_ns::db_51 m)
{
	DEBUG_STREAM << "plclgthread::log_states_new(): entering... dbtable='"<<t_PLCaccess->dbtable<<"'" << endl;
	
	char query[DB_QUERY_LEN];
	memset(query, 0, DB_QUERY_LEN);
	MYSQL_STMT    *stmt;
	MYSQL_BIND    log_bind[2];
	my_ulonglong  affected_rows;
	int           param_count;
	double         double_data;
	unsigned long blob_length;
	double		date_double, date_plc;
	my_bool       is_null;
	int y;
	timeval t_now;
	my_ulonglong id;
	// time_t mktime ( struct tm * timeptr );
	time_t rawtime;
	struct tm * ptm;

	time ( &rawtime );

	ptm = gmtime ( &rawtime );
	
	u_char *blk_db51_pointer;
	blk_db51_pointer = (u_char *) m.blk; 
	if (t_PLCaccess->blk_db51_buffer == NULL) { // <<<<<<<-----------------------
		for (int i=0; i<NUM_DATA_BLK*2; i++) {
			memset(query, 0, DB_QUERY_LEN);
			y = snprintf(query, DB_QUERY_LEN-1, "INSERT INTO %s_db51_%d SET byte=%d, value=%d", t_PLCaccess->dbtable, 1900+ptm->tm_year, i+12, blk_db51_pointer[i]);
			DEBUG_STREAM << __func__<< ": " << query << endl;
			if (mysql_query(&(t_PLCaccess->dbp), query)) {
				stringstream tmp;
				tmp << "1 Error inserting new DB51 Query='"<<query<<"' err='" <<mysql_error(&(t_PLCaccess->dbp)) <<"'";
				INFO_STREAM << "plctimingthread::"<<__func__ << ": " << tmp.str();
				*t_PLCaccess->attr_DBState_read = false;
				memset(t_PLCaccess->db_error,0,2048);
				strncpy(t_PLCaccess->db_error, tmp.str().c_str(), 2048);
				try
				{
					t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
					t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
				} catch(Tango::DevFailed &e)
				{
					INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
				}
			}
			else
			{
				DEBUG_STREAM << "1 Inserted OK new DB51 Query='"<<query<<"'"<< endl;
				*t_PLCaccess->attr_DBState_read = true;
				try
				{
					t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
					t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
				} catch(Tango::DevFailed &e)
				{
					INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
				}
			}
		}
	}
	else {
		gettimeofday(&t_now,NULL); //takes timestamp
		date_double = ((double) t_now.tv_sec) + ((double) t_now.tv_usec)/1000000;//change
		long int ll, mm;
		ll = t_PLCaccess->calc_timeval(m.year, m.month, m.day, m.hour, m.min, m.sec, m.wday);
		mm = t_PLCaccess->calc_time_ms(m.msec, m.wday);
		DEBUG_STREAM << "plctimingthread::" << __func__<< ": " << ll  << "." << mm << " -> Y=" <<hex<< (int)m.year << ", M=" << (int)m.month << ", D=" << (int)m.day << ", h=" << (int)m.hour << ", m=" << (int)m.min << ", s=" << (int)m.sec << ", ms=" << (int)m.msec << " wd=" << (int)m.wday <<dec<< endl;
		date_plc = ((double)ll) + ((double)mm)/1000.0;
		for (int i=0; i<NUM_DATA_BLK*2; i++) {
			if (i+12>=47 && i+12<64) continue; // skip some int values	//TODO: remove
			if (i+12>=323 && i+12<344) continue; // skip real values	//TODO: remove
			//if(t_PLCaccess->labels_stat[i+12][0] == 's' && t_PLCaccess->labels_stat[i+12][1] == 'p') continue;	//SPARE
			if (t_PLCaccess->blk_db51_buffer[i] != blk_db51_pointer[i]) {
				memset(query, 0, DB_QUERY_LEN);
				y = snprintf(query, DB_QUERY_LEN-1, "INSERT INTO %s_time_%d SET db_time=%13.3f, plc_time=%13.3f, valid='Y'", t_PLCaccess->dbtable, 1900+ptm->tm_year, date_double, date_plc);
				DEBUG_STREAM << __func__<< ": " << query << endl;
				if (mysql_query(&(t_PLCaccess->dbp), query)) {
					stringstream tmp;
					tmp << "2 Error inserting time. Query='"<<query<<"' err='" <<mysql_error(&(t_PLCaccess->dbp)) <<"'";
					INFO_STREAM << "plctimingthread::"<<__func__ << ": " << tmp.str();
					*t_PLCaccess->attr_DBState_read = false;
					memset(t_PLCaccess->db_error,0,2048);
					strncpy(t_PLCaccess->db_error, tmp.str().c_str(), 2048);
					try
					{
						t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
						t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
					} catch(Tango::DevFailed &e)
					{
						INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
					}
				}
				else
				{
					DEBUG_STREAM << "2 Inserted OK time. Query='"<<query<<"'"<< endl;
					*t_PLCaccess->attr_DBState_read = true;
					try
					{
						t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
						t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
					} catch(Tango::DevFailed &e)
					{
						INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
					}
				}
				id = mysql_insert_id(&(t_PLCaccess->dbp));
				// cout << id << endl;
				break;
			}
		}
		for (int i=0; i<NUM_DATA_BLK*2; i++) {
			if (i+12>=47 && i+12<64) continue; // skip some int values	//TODO: remove
			if (i+12>=323 && i+12<344) continue; // skip real values	//TODO: remove
			//if(t_PLCaccess->labels_stat[i+12][0] == 's' && t_PLCaccess->labels_stat[i+12][1] == 'p') continue;	//SPARE
			if (t_PLCaccess->blk_db51_buffer[i] != blk_db51_pointer[i]) {
				memset(query, 0, DB_QUERY_LEN);
				y = snprintf(query, DB_QUERY_LEN-1, "INSERT INTO %s_db51_%d SET time_id=%llu, byte_number=%d, value=%d", t_PLCaccess->dbtable, 1900+ptm->tm_year, id, i+12, blk_db51_pointer[i]);
				DEBUG_STREAM << __func__<< ": " << query << endl;
				if (mysql_query(&(t_PLCaccess->dbp), query)) {
					stringstream tmp;
					tmp << "3 Error inserting DB51. dbtable='"<<t_PLCaccess->dbtable<<"'. Query='"<<query<<"' err='" <<mysql_error(&(t_PLCaccess->dbp)) <<"'";
					INFO_STREAM << "plctimingthread::"<<__func__ << ": " << tmp.str();
					*t_PLCaccess->attr_DBState_read = false;
					memset(t_PLCaccess->db_error,0,DB_QUERY_LEN*2);
					strncpy(t_PLCaccess->db_error, tmp.str().c_str(), DB_QUERY_LEN*2);
					try
					{
						t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
						t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
					} catch(Tango::DevFailed &e)
					{
						INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
					}
				}
				else
				{
					INFO_STREAM << "3 Inserted OK DB51. Query='"<<query<<"'"<< endl;
					*t_PLCaccess->attr_DBState_read = true;
					try
					{
						t_PLCaccess->push_change_event("DBState",t_PLCaccess->attr_DBState_read);
						t_PLCaccess->push_archive_event("DBState",t_PLCaccess->attr_DBState_read);
					} catch(Tango::DevFailed &e)
					{
						INFO_STREAM << "plctimingthread::"<<__func__ << ": error pushing events, err=" << e.errors[0].desc << endl;
					}
				}
				t_PLCaccess->blk_db51_buffer[i] = blk_db51_pointer[i];
			}
		}
	}
}


